{$B-,I+,R-,S-,T-,X+}

{(C)98 by CARSTEN WAECHTER aka THE TOXIC AVENGER}
{(C)2006 Game ported by MARKUS TRENKWALDER }

UNIT Fli;

INTERFACE

USES mode13p,control,util;

TYPE fli_header = record
                 length   : UInt32;
                 magic    : UInt16;    {=$AF11}
                 frames   : UInt16;
                 res_x    : UInt16;    {=320}
                 res_y    : UInt16;    {=200}
                 col_depth: UInt16;    {=8}
                 flags    : UInt16;
                 speed    : UInt16;
                 next     : UInt32;
                 frit     : UInt32;
                 expand   : array[1..102]of Uint8;
                end;

     frame_header = record
                 length   : UInt32;
                 magic    : UInt16;    {=$F1FA}
                 chunks   : UInt16;
                 expand   : array[1..8]of Uint8;
                end;

     chunk_header = record
                 length   : UInt32;
                 typ      : UInt16;
                end;


PROCEDURE fli_2_mem(var vscr : array of pointer;name : string;pal : boolean;var lastframe : word);
{ Bedingungen : 1 Frame nicht groesser 64KB, 8Bit, 1 Farbtabelle }


IMPLEMENTATION

procedure fli11(dat : pointer);
begin
	Assert(false, 'flic type 11 not implemented');
	halt(0);
end;

procedure fli12(dat,dest : pointer;resx : word);
begin
end;

procedure fli15(dat,dest : pointer;lines : word);
var dst : Pint8 := Pint8(dest);
var src : Pint8 := Pint8(dat);
begin
	while lines > 0 do begin
		var pcount : Uint8 := src^; inc(src);
		while pcount > 0 do begin
			var rle_cnt : Int8 := src^; inc(src);
			if rle_cnt < 0 then begin
				repeat
					dst^ := src^; inc(dst); inc(src);
					inc(rle_cnt);
				until rle_cnt = 0;
			end else begin
				var data : Int8 := src^; inc(src);
				while rle_cnt > 0 do begin
					dst^ := data; inc(dst);
					dec(rle_cnt);
				end;
			end;
			dec(pcount);
		end;
		dec(lines);
	end;	
end;

procedure fli4(dat : pointer);
begin
	Assert(false, 'flic type 4 not implemented');
	halt(0);
end;

procedure fli7(data,dest : pointer;resx : word);
var
	lines     : Uint16;
	src       : PUint16 := Pint16(data);
	dst       : PUint16 := Pint16(dest);
begin
	lines := src^; inc(src);
	while lines > 0 do begin
		var opcode : Int16 := src^; inc(src);
		if (opcode and $C000) = 0 then begin
			var pcount : Uint16 := opcode;
			var dst_tmp : PUint16 := dst;
			while pcount > 0 do begin
				var packet : Uint16 := src^; inc(src);
				var col_skip  : Uint8 := Uint8(packet and $FF);
				var rle_count : Int8 := Int8((packet and $FF00) shr 8);
				
				inc(dst, col_skip shr 1);
				
				if ( rle_count > 0 ) then begin
					repeat
						dst^ := src^; inc(dst); inc(src);
						dec(rle_count);
					until rle_count = 0;
				end else begin
					var d : UInt16 := src^; inc(src);
					while rle_count < 0 do begin
						dst^:= d; inc(dst);
						inc(rle_count);
					end;		
				end;
				dec(pcount);
			end;
			dst := dst_tmp + (resx shr 1);
		end else if (opcode and $C000) = $C000 then begin
			inc(dst, -opcode * (resx shr 1));
		end else if (opcode and $C000) = $8000 then begin
			Assert(false, 'This case is not yet handled');
		end;
		dec(lines);
	end;
	
end;

PROCEDURE fli_2_mem(var vscr : array of pointer; name : string; pal : boolean; var lastframe : word);
 Const frames=400;
 Var   fli_datei : file;
       fli_h     : fli_header;

       v,v2 : word;

       frame_h     : array[1..frames]of frame_header;
       chunk_h     : array[1..frames,1..2]of chunk_header;

       data   : PUint8;
       flipos : word;

BEGIN

  assign(fli_datei,name);
  reset(fli_datei,1);
  blockread(fli_datei,fli_h,128);

  data:=globalallocptr(0,65535);
  flipos:=0;

  for v:=1 to fli_h.frames do begin
    blockread(fli_datei,frame_h[v],16);

    if (frame_h[v].chunks>0) then
     for v2:=1 to frame_h[v].chunks do begin

      blockread(fli_datei,chunk_h[v,v2],6);
      blockread(fli_datei,data^,chunk_h[v,v2].length-6);

      case chunk_h[v,v2].typ of
       4  : if pal then fli4(data);
       7  : begin
             vscr[flipos]:=globalallocptr(0,fli_h.res_x*fli_h.res_y);
             if (flipos>0) then moved(vscr[flipos-1],vscr[flipos],(fli_h.res_x*fli_h.res_y) shr 2);
             fli7(data,vscr[flipos],fli_h.res_x);
             inc(flipos);
            end;
       11 : if pal then fli11(data);
       12 : begin
			 Assert(false, 'flic type 12 not implemented');
			 (*
             vscr[flipos]:=globalallocptr(0,fli_h.res_x*fli_h.res_y);
             if (flipos>0) then moved(vscr[flipos-1],vscr[flipos],(fli_h.res_x*fli_h.res_y) shr 2);
             fli12(data,vscr[flipos],320);
             inc(flipos);*)
            end;
       13 : begin
			 Assert(false, 'flic type 13 not implemted');
			 (*
             vscr[flipos]:=globalallocptr(0,fli_h.res_x*fli_h.res_y);
             if (flipos>0) then moved(vscr[flipos-1],vscr[flipos],(fli_h.res_x*fli_h.res_y) shr 2);
             filld(vscr[flipos],(fli_h.res_x*fli_h.res_y) shr 2,0);
             inc(flipos);*)
            end;
       15 : begin
             vscr[flipos]:=globalallocptr(0,fli_h.res_x*fli_h.res_y);
             if (flipos>0) then moved(vscr[flipos-1],vscr[flipos],(fli_h.res_x*fli_h.res_y) shr 2);
             fli15(data,vscr[flipos],fli_h.res_y);
             inc(flipos);
            end;
       16 : begin
			 { uncompressed image }
             vscr[flipos]:=globalallocptr(0,fli_h.res_x*fli_h.res_y);
             if (flipos>0) then moved(vscr[flipos-1],vscr[flipos],(fli_h.res_x*fli_h.res_y) shr 2);
             moved(data,vscr[flipos],(fli_h.res_x*fli_h.res_y) shr 2);
             inc(flipos);
            end;
      end;
     end;
  end;

  close(fli_datei);

  lastframe:=flipos-1;
  globalfreeptr(data);


END;


END.