{$B-,I+,R-,S-,T-,X+}

{(C)98 by CARSTEN WAECHTER aka THE TOXIC AVENGER}
{(C)2006 Game ported by MARKUS TRENKWALDER }

UNIT Mode13p;

INTERFACE

USES util;

TYPE LinSprite = record
                  adr : pointer;
                  dtx,dty : Uint32;
                 end;

     PCX_header= record
                  Manufacturer : UInt8; { Constant Flag, 10 = ZSoft }
                  Version      : UInt8; { 5 = Version 3.0+ ( evtl. 24bit) }
                  Encoding     : UInt8; { 1 = PCX run length encoding }
                  BitsPerPixel : UInt8; { per plane }
                  xmin,ymin    : UInt16;
                  xmax,ymax    : UInt16;
                  HorizDpi     : UInt16;
                  VertiDpi     : UInt16;
                  Colormap     : array[0..47]of UInt8;
                  Reserved     : UInt8; { 0 }
                  NPlanes      : UInt8; { Number of color planes }
                  BytesPerLine : UInt16; { scanline length }
                  PaletteInfo  : UInt16; { 1 = Color/BW,2 = Grayscale }
                  HscreenSize  : UInt16;
                  VscreenSize  : UInt16;
                  Filler       : array[0..53]of UInt8; { 0 }
                 end;

VAR
  Palette : array[0..767] of UInt8;

PROCEDURE waitretrace; external name "waitretrace";

PROCEDURE filld(dest : pointer; anz : UInt32; col : UInt8); external name "filld";
PROCEDURE moved(source,dest : pointer; anz : UInt32); external name "moved";
PROCEDURE decpalette(num : UInt8; pal : pointer); external name "decpalette";
PROCEDURE setpalette(pal : pointer); external name "setpalette";

PROCEDURE getsprite13(source : pointer;offs,dtx,dty : word;var Typ : LinSprite);
PROCEDURE mirrorsprite13(typ_in : linsprite;var typ_out : linsprite);

PROCEDURE pcx_2_mem(dest : pointer;name : string;pal : boolean);


IMPLEMENTATION

PROCEDURE getsprite13(source : pointer;offs,dtx,dty : word;var Typ : LinSprite);
VAR
	src, dst : PChar;
	x, y : Word;
BEGIN
  Typ.adr:=GlobalAllocPtr(0,dtx*dty);
  Typ.dtx:=dtx;
  Typ.dty:=dty;

  dst := PChar(Typ.adr);
  src := PChar(source) + offs;
  
  for y := 1 to dty do begin
    for x := 1 to dtx do begin
	  dst^ := src^;
	  inc(src);
	  inc(dst);
    end;
	inc(src, 320 - dtx);
  end;
  
END;


PROCEDURE mirrorsprite13(typ_in : linsprite;var typ_out : linsprite);
VAR
	x, y : Word;
	src, dst : PChar;
BEGIN
  typ_out.adr:= GlobalAllocPtr(0,typ_in.dtx*typ_in.dty);
  typ_out.dtx:=typ_in.dtx;
  typ_out.dty:=typ_in.dty;
  
  src := PChar(typ_in.adr);
  dst := PChar(typ_out.adr) + typ_out.dtx - 1;
  for y := 1 to typ_out.dty do begin
    for x := 1 to typ_out.dtx do begin
	  dst^ := src^;
	  dec(dst);
	  inc(src);
    end;
	inc(dst, 2 * typ_out.dtx)
  end;  

END;


PROCEDURE pcx_2_mem(dest : pointer;name : string;pal : boolean);
 Var f : file;
     total_length : word;
     source : PUint8;
     pcx_h  : pcx_header;
BEGIN
  assign(f,name);
  reset(f,1);

  blockread(f,pcx_h,128);                   { HEADER }
  total_length:=(pcx_h.xmax-pcx_h.xmin+1)*(pcx_h.ymax-pcx_h.ymin+1);

  Source:=GlobalAllocPtr(0,filesize(f)-896);{ 768 (PAL) +128 (HEADER) }
  blockread(f,source^,filesize(f)-896);     { UEBERFLUESSIGES BYTE WIRD AUCH GELESEN }
  if pal then blockread(f,palette,768);
  close(f);
  
  var dst : PUInt8;
  var src : PUInt8;
  var color : Uint8;
  var count : Word;

  dst := PUInt8(dest);
  src := PUint8(source);
  count := 0;
  while total_length > 0 do begin
    if count = 0 then begin
      color := src^; inc(src);
      if (color and $C0) = $C0 then begin
        count := color and $3F;
        color := src^; inc(src);
      end else count := 1;
    end;
    dst^ := color; inc(dst);
    dec(count); dec(total_length);
  end;

  GlobalFreePtr(source);

  if pal then setpalette(@palette);

END;

END.
